#ifndef __XTEXT_
#define __XTEXT_ 

#include <X11/Intrinsic.h>
#include <X11/keysym.h>

#if HAVE_LIBXFT
#include <X11/Xft/Xft.h>
#include <X11/extensions/Xrender.h>
#endif

#define T_NAME	"-- []ư [Enter]ѹ,¹ --"
#define S_NAME0	"ꥹȴñ(ɽԲ)"
#define S_NAME1 "θ򡢴ޤࡣ"
#define XJP_OK  "xjp-ok"
#define XJP_CANCEL  "xjp-cancel"
#define STEP_MAX 8


enum {
	XJP_NONE = -1,
	XJP_INT,
	XJP_CHA,
	XJP_STR,
	XJP_COL,
	XJP_FONT
};
enum {
	XJP_LEFT = -1,
	XJP_CENTER,
	XJP_RIGHT
};
typedef struct OTHERFILEPROG{
	char *name;
	char *exec;
	char *data;
	struct OTHERFILEPROG *next;
	struct OTHERFILEPROG *prev;
}other_prog_t;
typedef struct{
	int main_window_width;
	int main_window_height;
	char *main_window_img;
	char *main_window_color;
	char *main_font_color;
	char *main_shadow_color;
	char *find_font_color;
	char *rubi_font_color;
	char *menu_window_color;
	char *menu_font_color;
	char *select_window_color;
	char *select_font_color;
	char *select_font_background_color;
	char *main_font_j;
	char *main_font_s;
	char *main_font_e;
	char *book_dir;
	char *rubi_font;

	char page_next[8];
	char page_prev[8];
	char conf_page[8];
	char book_mark[8];
	char siori_menu[8];
	char quit[8];
	char menu[8];
	char title_key[8];
	char kinsc_key[8];
	char chuki_key[8];
	char page_key[8];
	char net_key[8];
	char cursor_key[8];
	char other_key[8];
	char find_key[8];
	char find_next[8];
	char find_prev[8];

	int anti;
	int title_on;
	int ruby_on;
	int page_on;
	int kinsc;
	int cursor;
	int chuki;
	int line_space;
	int row_space;
	int max_line;

	other_prog_t *other_head;
	other_prog_t *other_tail;

}xtext_conf_t;
typedef struct{
	Window win;
	/*Window cwin;*/
	Window mwin;
	int width;
	int height;
	struct {
		Pixmap img;
		int width;
		int height;
		char *position;
	}image;
	GC gc;
	GC bgc;
	GC fgc,rfgc;
	GC rubi_gc;
	GC find_gc;
	GC sgc;
	XFontSet fs;
	XFontSet fs_s;
	XFontSet fs_e;
	XFontSet rubi_fs;
	long fg_pixel;
	long bg_pixel;
	long menu_fg_pixel;
	long menu_bg_pixel;
	long rubi_fg_pixel;
	long rubi_bg_pixel;
#if HAVE_LIBXFT
	XftFont	*font;
	XftFont *font_s;
	XftFont *font_e;
	XftFont *font_rubi;
	XftDraw	*draw;
	XftColor fg_color;
	XftColor bg_color;
	XftColor rubi_color;
	XftColor find_color;
	XftColor menu_fg_color;
	XftColor menu_bg_color;
#endif
	Visual	*visual;
	Colormap cmap;
	int kinsc;
	int anti;
	int title_on;
	int page_on;
	int cursor;
}my_window_t;
typedef struct {
	Window parent_win;
	Window win;
	int x;
	int y;
	int width;
	int height;
	GC gc;
	GC bgc;
	GC fgc;
	GC rfgc;
	GC sgc;
	long fg_pixel;
	long bg_pixel;
	XFontSet fs;
#if HAVE_LIBXFT
	XftFont	*font;
	XftDraw	*draw;
	XftColor menu_fg_color;
	XftColor menu_bg_color;
#endif
	Visual	*visual;
	Colormap cmap;
}my_subwindow_t;
typedef struct CHARIMAGE{
	unsigned char c1;
	unsigned char c2;
	short flag;
	XImage *char_image;
	struct CHARIMAGE *next;
	struct CHARIMAGE *prev;
}image_data_t;
typedef struct PAGEDATA{
	int char_no;
	int page_no;
	struct PAGEDATA *next;
	struct PAGEDATA *prev;
}page_data_t;
typedef struct {
	char *book_path;
	char *book_title;
	char *book_title_utf8;
	int total_page;
}book_data_t;
typedef struct DRAWDATA{
	int char_header;
	int char_footer;
	int one_line;
	int start_line;
	int end_line;
	int start_low;
	int end_low;
}draw_data_t;
typedef struct CHUDATA{
        char message[256];
        struct CHUDATA *next;
        struct CHUDATA *prev;
}chu_data_t;
typedef struct {
	int charSize;
	int charSize_s;
	int charSize_e;
	int charSize_r;
	int m_off;
	int s_off;
	int e_off;
	int xpad;
	int ypad;
	draw_data_t *draw;
	book_data_t *book;
	page_data_t *head;
	page_data_t *tail;
	page_data_t *find_head;
	page_data_t *find_tail;
	image_data_t *im_head;
	image_data_t *im_tail;
}char_data_t;
typedef struct SUBWINDOWDATA{
	char *line_str;
	void *line_data;
	char *re_str;
	int (*func)();
	void *func_data0;
	int func_data1;
	int type;
	int line_no;
	int mstr;
	int mdata;
	struct SUBWINDOWDATA *next;
	struct SUBWINDOWDATA *prev;
}sub_window_t;
typedef struct CTRLWINDOWDATA{
	char *name;
	int xpos0;
	int xpos1;
	int ypos0;
	int ypos1;
	int (*func)();
	void *func_data0;
	struct CTRLWINDOWDATA *next;
	struct CTRLWINDOWDATA *prev;
}ctl_window_t;
typedef struct XOFFSET {
        char font[128];
        unsigned int c1;
        unsigned int c2;
        int anti;
        int x_off;
        int y_off;
        struct XOFFSET *next;
        struct XOFFSET *prev;
}offset_data_t;
typedef struct XJP_FONT_DATA {
        char name[100];
        struct XJP_FONT_DATA *head;
        struct XJP_FONT_DATA *tail;
        struct XJP_FONT_DATA *next;
        struct XJP_FONT_DATA *prev;
}xtext_font_t;
typedef struct XJP_EFONT_DATA{
        char name[50];
        struct XJP_EFONT_DATA *next;
        struct XJP_EFONT_DATA *prev;
}xtext_efont_t;

int xtext_Init_Text(Display *,my_window_t *,ICONTENT_T *,char_data_t *);
int xtext_Draw_Text(Display *,my_window_t *,ICONTENT_T *,char_data_t *,page_data_t *);
page_data_t * xtext_Init_Book(Display *,my_window_t *,ICONTENT_T *,char_data_t *,offset_data_t *,xtext_conf_t *,char *,int);
page_data_t * xtext_Redraw_Text(Display *,my_window_t *,ICONTENT_T *,char_data_t *,int);
char *xtextSubWindow(Display *,my_window_t,sub_window_t *,sub_window_t *,int,int);
char *xtextInputWindow(Display *,my_window_t *,char *,char *,int);
int xtextSubWindow_Message(Display *,my_window_t,char *);
int xtext_check_image_data(ITEXT_T *);
int xtext_next_kuten(ITEXT_T *,char_data_t *,int);
int xtext_prev_kuten(ITEXT_T *,char_data_t *,int);
int xtext_get_low_space(ITEXT_T *,char_data_t *);
int xtext_get_low_pos(ITEXT_T *,char_data_t *);
int xtextBookData2Sub(sub_window_t **,sub_window_t **,IBOOK_T *,int);
int xtextSioriData2Sub(sub_window_t **,sub_window_t **,ISIORI_T *);
int xtextClearChuMessage(Display *,my_window_t *);
int xtextDrawChuMessage(Display *,my_window_t *,char_data_t *);
int xtextChuMessage(Display *,my_window_t *,char_data_t *,char *);
int xtextCursorType(Display *,my_window_t *,char *);
void xtext_usage(char *,double);
int select_book_data(void *,int);
int select_siori_data(void *,int);
int select_person_data(void *,int);
int select_serch_data(void *,int);
sub_window_t * _subwindow_data_alloc();
void * subwindow_data_free(sub_window_t **,sub_window_t **);
void * subwindow_data_add(sub_window_t **,sub_window_t **,sub_window_t *);
int xtext_get_string_size(Display *,my_window_t *,char *,char *,int *,int *,int);
int xtextDrawPageTitleString(Display *,my_window_t *,char *,char *,int ,int ,int);
int xtextCheckFindData(ICONTENT_T *,char_data_t *,char *);
int page_data_insert(page_data_t **,page_data_t **,int,int);
void page_data_free(page_data_t **,page_data_t **);
/*
void * _subwindow_data_insert(sub_window_t **,sub_window_t **,char *,char *,char *,int,void *,int ,int ,int );
*/
int xtext_Draw_Help(Display *,my_window_t *,xtext_conf_t *);
int xtextHelpData2Sub(sub_window_t **,sub_window_t **,xtext_conf_t *);
char * xtext_conf_data(xtext_conf_t *);
int xtext_conf_change(void *,int);
int xtext_conf_quit(void *,int);
int xtext_conf_save(void *,int);
void SetOffset(char *,int,int);
void GetOffset(char,int *,int *);
void euc2utf8_c(iconv_t,char *,char *,int);
char *euc2utf8(iconv_t,char *,int);
unsigned int xstring2uint(char *);
int checkStepNumber(char *,char[],int);

int xtext_offt_data(offset_data_t **,offset_data_t **);
int xtext_set_offset(IBUF_T *,IBUF_T *,offset_data_t *);
int xtext_offt_set(	offset_data_t *,
			offset_data_t *,
			xtext_conf_t *,
			offset_data_t **,
			offset_data_t **		);

char *xtext_Selector_Window(char *,int);
int xtext_font_J2E(char *,char *);
int parse_xlfd_No(char *,char *,int);
int xtext_xlfd_create(xtext_font_t **,xtext_font_t **,char *);
int xtext_xlfd_getenco(xtext_efont_t **,xtext_efont_t **,char *);
int xtext_xlfd_free(xtext_font_t *);
int xtext_xlfd_free_e(xtext_efont_t *);

#endif
