#include "itext.h"
#include "xtext.h"
#include "xjp.h"

#define debug 0

extern 	char *XJP_MESSAGE[];
extern 	iconv_t XJP_CONV;

XImage *bimg;

void  page_data_free(page_data_t **start,page_data_t **end)
{
	page_data_t *pt,*ptt;

	for(pt = *start;pt!=NULL;pt=ptt){
		ptt = pt->next;
		free(pt);
	}

	*start = NULL;
	*end = NULL;
}
static page_data_t * _page_data_alloc()
{
	page_data_t *pt;

	if((pt = (page_data_t *)malloc(sizeof(page_data_t))) == NULL) return NULL;
	pt->char_no = 0;

	return pt;
}
static void *_page_data_add(page_data_t **start,page_data_t **end,page_data_t *mg)
{
        if(*end){
                mg->next = NULL;
                mg->prev = *end;

                (*end)->next = mg;
                *end = mg;
        }else{
                mg->next = NULL;
                mg->prev = NULL;

                *end = mg;
                *start = mg;
        }

	return NULL;
}
int page_data_insert(page_data_t **start,page_data_t **end,int n,int np)
{
	page_data_t *pt;

	if((pt = (page_data_t *)_page_data_alloc()) == NULL) return -1;
	pt->char_no = n;
	pt->page_no = np+1;
	_page_data_add(start,end,pt);

	return 0;
}
static int _xtext_get_normalfont_size(my_window_t *win,char_data_t *ct)
{
	unsigned char *str = "";
	char *str_e = "W";
	XRectangle ink,log;

	XmbTextExtents(win->fs,str,strlen(str),&ink,&log);
	ct->charSize = log.width >= log.height ? log.width+2 : log.height+2;

	XmbTextExtents(win->fs_s,str,strlen(str),&ink,&log);
	ct->charSize_s = log.width >= log.height ? log.width+2 : log.height+2;

	XmbTextExtents(win->fs_e,str_e,strlen(str_e),&ink,&log);
	ct->charSize_e = log.width+2;

	XmbTextExtents(win->rubi_fs,str,strlen(str),&ink,&log);
	ct->charSize_r = log.width >= log.height ? log.width : log.height;

	return 0;
}
static int _xtext_get_antifont_size(Display *disp,my_window_t *win,char_data_t *ct)
{
#if HAVE_LIBXFT
	unsigned char *str = "";
	char *str_e = "W";

	XGlyphInfo gi;
	char *utf8;

	utf8 = (char *)euc2utf8(XJP_CONV,str,strlen(str));

	XftTextExtentsUtf8(disp,win->font,utf8,strlen(utf8),&gi);
	ct->charSize = gi.width >= gi.height ? gi.width+2 : gi.height+2;

	XftTextExtentsUtf8(disp,win->font_s,utf8,strlen(utf8),&gi);
	ct->charSize_s = gi.width >= gi.height ? gi.width+2 : gi.height+2;

	XftTextExtents8(disp,win->font_e,str_e,strlen(str_e),&gi);
	ct->charSize_e = gi.width+2;

	if(utf8) free(utf8);

	utf8 = (char *)euc2utf8(XJP_CONV,str,strlen(str));
	XftTextExtentsUtf8(disp,win->font_rubi,utf8,strlen(utf8),&gi);
	ct->charSize_r = gi.width >= gi.height ? gi.width : gi.height;
	if(utf8) free(utf8);
#else

	_xtext_get_normalfont_size(win,ct);

#endif

	return 0;
}
static draw_data_t * _xtext_get_draw_data(my_window_t *win,char_data_t *ct,int header,int footer)
{
	draw_data_t *dt;
	int one_line;

	if(win == NULL || ct == NULL) return NULL;

	if((dt = (draw_data_t *)malloc(sizeof(draw_data_t))) == NULL){
		fprintf(stderr,"False _get_draw_data()(malloc())\n");
		return NULL;
	}
	one_line = ct->charSize + ct->xpad + ct->charSize_r;

	dt->start_line = win->width - one_line;
	dt->end_line = 2;
	dt->start_low = ct->charSize * header;
	dt->end_low = win->height - ct->charSize * footer;
	dt->one_line = one_line;
	dt->char_header = header;
	dt->char_footer = footer;

	return dt;
}
int xtext_Init_Text(Display *disp,my_window_t *win,ICONTENT_T *book,char_data_t *ct)
{
	IBUF_T *ib;
	ITEXT_T *it;
	draw_data_t *dt;

	int KINSOKU = 0,CHAR_HEADER = 0,CHAR_FOOTER = 0;
	int page_char_no = 0, total_page = 0;
	int type,x,y,h;

	if(win->fs == NULL){
		fprintf(stderr,"ERROR : Font False\n");
		exit(1);
	}

	xtext_usage(NULL,0);

	if(ct->im_head != NULL) _image_data_free(&ct->im_head,&ct->im_tail);
	if(ct->head != NULL) page_data_free(&ct->head,&ct->tail);
	if(ct->draw != NULL) free(ct->draw);

	if(win->anti == 0)
		_xtext_get_normalfont_size(win,ct);
	else
		_xtext_get_antifont_size(disp,win,ct);

	if(bimg) XDestroyImage(bimg);
	bimg = (XImage *)xtext_get_bimage(disp,win,ct);

	CHAR_HEADER = 3;
	switch(KINSOKU = win->kinsc){
		case 0: CHAR_FOOTER = 1;break;
		case 1: CHAR_FOOTER = 2;break;
		case 2: CHAR_FOOTER = 3;break;
	}	

	if((dt = (draw_data_t *)_xtext_get_draw_data(win,ct,CHAR_HEADER,CHAR_FOOTER)) == NULL) return -1;
	ct->draw = dt;
	x = dt->start_line;
	y = dt->start_low;

	page_data_insert(&ct->head,&ct->tail,0,total_page++);

	for(ib=book->b_head;ib!=NULL;ib=ib->next){
		xtext_usage(XJP_MESSAGE[8],(double)ib->line/book->total_line);

		for(it=ib->i_head;it!=NULL;it=it->next){

			if((type = xtext_check_image_data(it)) > 0){
				OnFlag(it->flag,_FND);
				xtext_image_data_insert(disp,win,ct,it,type);
				OfFlag(it->flag,_FND);
				xtext_image_data_insert(disp,win,ct,it,type);
			}

			if(ChFlag(it->flag,_LST) || ChFlag(it->flag,_TOP)) y = xtext_get_low_pos(it,ct);

			h = xtext_get_low_space(it,ct);
			page_char_no++;

			if((y += h) > dt->end_low){
				if(xtext_next_kuten(it,ct,KINSOKU) == 0){
					if((x -= dt->one_line) <= dt->end_line){
						page_data_insert(&ct->head,&ct->tail,page_char_no,total_page++);
						x = dt->start_line;
					}
					if(xtext_prev_kuten(it,ct,KINSOKU) == 1){
						it=it->prev;
						page_char_no--;
					}
					y = dt->start_low;
				}
			}
		}
		if((x -= dt->one_line) <= dt->end_line){
			page_data_insert(&ct->head,&ct->tail,page_char_no,total_page++);
			x = dt->start_line;
		}
		y = dt->start_low;
	}
	ct->book->total_page = total_page;

	xtext_usage(NULL,0);

	return total_page;
}
page_data_t * xtext_Redraw_Text(	Display *disp,
					my_window_t *win,
					ICONTENT_T *book,
					char_data_t *char_d,
					int npc			)
{
	page_data_t *char_p;

        if(book->b_head == NULL) return NULL;

        xtext_Init_Text(disp,win,book,char_d);

	for(char_p=char_d->head;char_p!=NULL;char_p=char_p->next){
		if(char_p->next == NULL) return char_p;
		if(npc >= char_p->char_no && npc < char_p->next->char_no) return char_p;
	}
	return char_d->head;
}
page_data_t *  xtext_Init_Book(		Display *disp,
					my_window_t *win,	
					ICONTENT_T *main_book,
					char_data_t *char_d,
					offset_data_t *offset,
					xtext_conf_t *xconf,
					char *book_name,
					int npc			)
{
	page_data_t *char_p;
        int total_line;

	if(main_book->titlename != NULL) free(main_book->titlename);
        if(main_book->b_head != NULL) ibuf_data_free(main_book);
        if(char_d->book != NULL){
                if(char_d->book->book_title_utf8 != NULL) 
			free(char_d->book->book_title_utf8);
		free(char_d->book);
		char_d->book = NULL;
	}

        main_book->filename = book_name;
	main_book->titlename = NULL;
        if((total_line = itextGetTextData(main_book,xconf->ruby_on,xconf->max_line))<0){
		main_book->filename = NULL;
		main_book->titlename = NULL;
	       	return NULL;
	}
        main_book->total_line = total_line;

        xtext_set_offset(main_book->b_head,main_book->b_tail,offset);

        char_d->book = (book_data_t *)malloc(sizeof(book_data_t));
        char_d->book->book_path = main_book->filename;
        char_d->book->book_title = main_book->titlename;
        char_d->book->book_title_utf8 = (char *)euc2utf8(XJP_CONV,main_book->titlename,strlen(main_book->titlename));

        char_p = (page_data_t *)xtext_Redraw_Text(disp,win,main_book,char_d,npc);

	return char_p;
}



